
// USB_CheckDlg.cpp : t@C
//

#include "stdafx.h"
#include <Dbt.h>
#include "USB_Check.h"
#include "USB_CheckDlg.h"
#include "afxdialogex.h"
#include "HubUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CUSB_CheckDlg _CAO

CUSB_CheckDlg::CUSB_CheckDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CUSB_CheckDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSB_CheckDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_cListCtrl);
}

BEGIN_MESSAGE_MAP(CUSB_CheckDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CUSB_CheckDlg::OnBnClickedButton1)
	ON_WM_TIMER()
	ON_MESSAGE(WM_DEVICECHANGE, OnMyDeviceChange)
END_MESSAGE_MAP()


// CUSB_CheckDlg bZ[W nh[

BOOL CUSB_CheckDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	AutoCheckExecute = FALSE;
	InitGrid();
	UpdateUSBInfo();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CUSB_CheckDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CUSB_CheckDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CUSB_CheckDlg::InitGrid(void)
{
    LVCOLUMN    lvc;
    int         i;
    TCHAR       caption[][32] = {_T("No"), _T("PIC Serial"), _T("HUB Power"),_T("Device Status"),_T("VID"), _T("PID"), _T("Product Name")};
	int			width[] = {30, 70, 80, 120, 50, 50, 100};

    m_cListCtrl.SetExtendedStyle(m_cListCtrl.GetExtendedStyle() | LVS_EX_FULLROWSELECT);
	m_cListCtrl.DeleteAllItems();

	lvc.mask = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;    // LtO
    for (i = 0; i < 7; i++)
    {
        lvc.iSubItem    = i;            // TuACeԍ
        lvc.pszText     = caption[i];   // oeLXg
        lvc.cx          = width[i];     // 
        m_cListCtrl.InsertColumn(i, &lvc);
    }
}

void CUSB_CheckDlg::DispGrid(USB_1PORT_HUB_DEVICE_INFO *info)
{
    LVITEM  lvi;
    int     err = 0,index = 0;
	CString	buf;

	m_cListCtrl.DeleteAllItems();

	while(1){
		int row = m_cListCtrl.GetItemCount();

		lvi.mask = LVIF_TEXT;
		lvi.iItem = row+1;
		lvi.iSubItem = 0;
		buf.Format(_T("%d"),row+1);
		lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(buf));
		index = m_cListCtrl.InsertItem(&lvi);

		lvi.iItem = index;
		lvi.iSubItem = 1;
		lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(info->CtrlSerial));
		m_cListCtrl.SetItem(&lvi);

		lvi.iItem = index;
		lvi.iSubItem = 2;// HUB Power
		if(info->HUB_STATUS & 0x03){
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(_T("ON")));
		}else{
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(_T("OFF")));
		}
		m_cListCtrl.SetItem(&lvi);

		lvi.iItem = index;
		lvi.iSubItem = 3;// Device Status
		if(info->ConnectionStatus == USB_HUB_DeviceConnected){
			if(info->CurrentConfigurationValue){
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(_T("DeviceConnected")));
			}else{
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(_T("BadCondition")));
			}
			m_cListCtrl.SetItem(&lvi);

			lvi.iItem = index;
			lvi.iSubItem = 4;
			buf.Format(_T("0x%04X"),info->idVendor);
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(buf));
			m_cListCtrl.SetItem(&lvi);

			lvi.iItem = index;
			lvi.iSubItem = 5;
			buf.Format(_T("0x%04X"),info->idProduct);
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(buf));
			m_cListCtrl.SetItem(&lvi);

			lvi.iItem = index;
			lvi.iSubItem = 6;
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(info->cDeviceName));
			m_cListCtrl.SetItem(&lvi);
		}else{
			lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(_T("NoDeviceConnected")));
			m_cListCtrl.SetItem(&lvi);
		}

		if(!Hub_GetNextDeviceInfo(info)){
			break;
		}
	}
}

void CUSB_CheckDlg::UpdateUSBInfo()
{
	USB_1PORT_HUB_DEVICE_INFO devinfo;

	m_cListCtrl.DeleteAllItems();
	if(Hub_GetDeviceInfo(&devinfo)){
		DispGrid(&devinfo);
	}
}


void CUSB_CheckDlg::OnBnClickedButton1()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	USB_1PORT_HUB_DEVICE_INFO devinfo;
	CString buf;

	if(AutoCheckExecute){// STOP
		AutoCheckExecute = 0;
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(TRUE);
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_BUTTON1))->SetWindowTextW(_T("START"));
		KillTimer(1);
		if(Hub_GetDeviceInfo(&devinfo)){
			while(1){
				Hub_SetStatus(devinfo.CtrlSerial,1);// On
				if(!Hub_GetNextDeviceInfo(&devinfo)){
					break;
				}
			}
		}
	}else{// START
		AutoCheckExecute = 1;
		AutoCheckOn = 1;
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT1))->GetWindowTextW(buf);
		OnTime = _ttoi(buf);
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT2))->GetWindowTextW(buf);
		OffTime = _ttoi(buf);
		((CButton*)GetDlgItem(IDC_BUTTON1))->SetWindowTextW(_T("STOP"));
		SetTimer(1,OnTime*1000,NULL);
		LoopCount = 0;
		buf.Format(_T("Count % 10d"),LoopCount);
		((CStatic*)GetDlgItem(IDC_STATIC2))->SetWindowTextW(buf);
	}
}


void CUSB_CheckDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	CString buf;
	USB_1PORT_HUB_DEVICE_INFO devinfo;

	if(AutoCheckOn){
		AutoCheckOn = 0;
		if(Hub_GetDeviceInfo(&devinfo)){
			while(1){
				Hub_SetStatus(devinfo.CtrlSerial,0);// Off
				if(!Hub_GetNextDeviceInfo(&devinfo)){
					break;
				}
			}
		}
		SetTimer(1,OffTime*1000,NULL);
	}else{
		AutoCheckOn = 1;
		if(Hub_GetDeviceInfo(&devinfo)){
			while(1){
				Hub_SetStatus(devinfo.CtrlSerial,1);// On
				if(!Hub_GetNextDeviceInfo(&devinfo)){
					break;
				}
			}
		}
		LoopCount++;
		buf.Format(_T("Count % 10d"),LoopCount);
		((CStatic*)GetDlgItem(IDC_STATIC2))->SetWindowTextW(buf);
		SetTimer(1,OnTime*1000,NULL);
	}

	CDialogEx::OnTimer(nIDEvent);
}

LRESULT CUSB_CheckDlg::OnMyDeviceChange(WPARAM wParam, LPARAM lParam)
{
    CString mes = _T("");

	switch(wParam){
		case DBT_DEVNODES_CHANGED:
			UpdateUSBInfo();
			break;
		default:
			break;
    }

	return 0;
}
